---
title: llarp::service::Session

---

# llarp::service::Session





## Public Functions

|                | Name           |
| -------------- | -------------- |
| util::StatusObject | **[ExtractStatus](Classes/structllarp_1_1service_1_1Session.md#function-extractstatus)**() const |
| void | **[RX](Classes/structllarp_1_1service_1_1Session.md#function-rx)**()<br>called to indicate we recieved on this session  |
| void | **[TX](Classes/structllarp_1_1service_1_1Session.md#function-tx)**()<br>called to indicate we transimitted on this session  |
| bool | **[IsExpired](Classes/structllarp_1_1service_1_1Session.md#function-isexpired)**(llarp_time_t now, llarp_time_t lifetime =SessionLifetime) const |
| [Address](Classes/structllarp_1_1service_1_1Address.md) | **[Addr](Classes/structllarp_1_1service_1_1Session.md#function-addr)**() const |

## Public Attributes

|                | Name           |
| -------------- | -------------- |
| [Introduction](Classes/structllarp_1_1service_1_1Introduction.md) | **[replyIntro](Classes/structllarp_1_1service_1_1Session.md#variable-replyintro)** <br>the intro we have  |
| [SharedSecret](Classes/structllarp_1_1AlignedBuffer.md) | **[sharedKey](Classes/structllarp_1_1service_1_1Session.md#variable-sharedkey)**  |
| [ServiceInfo](Classes/structllarp_1_1service_1_1ServiceInfo.md) | **[remote](Classes/structllarp_1_1service_1_1Session.md#variable-remote)**  |
| [Introduction](Classes/structllarp_1_1service_1_1Introduction.md) | **[intro](Classes/structllarp_1_1service_1_1Session.md#variable-intro)** <br>the intro they have  |
| uint64_t | **[seqno](Classes/structllarp_1_1service_1_1Session.md#variable-seqno)** <br>the sequence number we are to use for the next message  |
| uint64_t | **[messagesSend](Classes/structllarp_1_1service_1_1Session.md#variable-messagessend)** <br>number of remote messages we sent to them  |
| uint64_t | **[messagesRecv](Classes/structllarp_1_1service_1_1Session.md#variable-messagesrecv)** <br>number of remote messages we got from them  |
| bool | **[inbound](Classes/structllarp_1_1service_1_1Session.md#variable-inbound)**  |
| bool | **[forever](Classes/structllarp_1_1service_1_1Session.md#variable-forever)**  |
| Duration_t | **[lastSend](Classes/structllarp_1_1service_1_1Session.md#variable-lastsend)**  |
| Duration_t | **[lastRecv](Classes/structllarp_1_1service_1_1Session.md#variable-lastrecv)**  |

## Public Functions Documentation

### function ExtractStatus

```cpp
util::StatusObject ExtractStatus() const
```


### function RX

```cpp
void RX()
```

called to indicate we recieved on this session 

### function TX

```cpp
void TX()
```

called to indicate we transimitted on this session 

### function IsExpired

```cpp
bool IsExpired(
    llarp_time_t now,
    llarp_time_t lifetime =SessionLifetime
) const
```


### function Addr

```cpp
Address Addr() const
```


## Public Attributes Documentation

### variable replyIntro

```cpp
Introduction replyIntro;
```

the intro we have 

### variable sharedKey

```cpp
SharedSecret sharedKey;
```


### variable remote

```cpp
ServiceInfo remote;
```


### variable intro

```cpp
Introduction intro;
```

the intro they have 

### variable seqno

```cpp
uint64_t seqno = 0;
```

the sequence number we are to use for the next message 

### variable messagesSend

```cpp
uint64_t messagesSend = 0;
```

number of remote messages we sent to them 

### variable messagesRecv

```cpp
uint64_t messagesRecv = 0;
```

number of remote messages we got from them 

### variable inbound

```cpp
bool inbound = false;
```


### variable forever

```cpp
bool forever = false;
```


### variable lastSend

```cpp
Duration_t lastSend {};
```


### variable lastRecv

```cpp
Duration_t lastRecv {};
```


-------------------------------

Updated on 2023-03-26 at 04:03:14 +0000